
#include "car.h"

void Car::init() {
    
    _speed = 0.0f;
    _car_position = 0.0f; 
    _direction = 0.0f;       
    }

void Car::draw(N5110 &lcd, int screenWidth) {
    
    int position = screenWidth / 2 + ((int)screenWidth * _car_position )/2.0f - 7;
    if(position < 0) position = 0;
    
    switch ( _direction ) {
        case 0:
            lcd.drawSprite(position, 36, 6, 9, car1);
            break;
        case 1:
            lcd.drawSprite(position, 36, 6, 9, car3);
            break;
        case 2:
            lcd.drawSprite(position, 36, 6, 9, car2);
    }
    }
// mutators
void Car::set_fuel(int _fuel) {
    
    this->_fuel = _fuel;
    
    }
    
void Car::set_health(int _health) {
    
    this->_health = _health;
    
    }

void Car::set_direction(int _direction) {
    
    this->_direction = _direction;
    
    }


void Car::set_car_distance(float distance) {
    
    this->_car_distance = distance;
    
    }
      
void Car::set_speed(float speed) {
    
    this->_speed = speed;
    // clamp speed
    if ( _speed < 0.0f) _speed = 0.0f;
    if ( _speed > 1.0f) _speed = 1.0f;
    
    }
    
void Car::set_car_position(float _position) {
    
    this->_car_position = _position;
    
    }
    
void Car::set_gear() {
       
    this->_gear = 1;
    this->_rev = 0.3; 
        
    }

void Car::set_rev(float r) {
    
    this->_rev = r;
    
    }
// accessors
int Car::get_fuel() {
    
        return _fuel;
    }
    
int Car::get_health() {
    
        return _health;
    }
    
int Car::get_direction() {
    
        return _direction;
    }

float Car::get_car_distance() {
   
        return _car_distance;
    }
       
float Car::get_speed() {
    
        return _speed;
    }
    
float Car::get_car_position() {
        
        return _car_position;
    }
    
float Car::get_rev() {
    
        return _rev;
    }
void Car::upShift() {
        
        if(_gear < 3) {
            _gear++;
            switch (_gear) {
                case 1:
                    _rev = 0.3f;
                    break;
                case 2:
                    _rev = 0.6f;
                    break;
                case 3:
                    _rev = 1.0f;
                    break;
            }
        } 
    }    
void Car::downShift() {
    
        if(_gear > 1) {
        _gear--;
           switch (_gear) {
                case 1:
                    _rev = 0.3f;
                    break;
                case 2:
                    _rev = 0.6f;
                    break;
                case 3:
                    _rev = 1.0f;
                    break;
            }    
        }
    }      
int Car::car1[6*9] = {
        0,0,0,0,1,0,0,0,0,
        0,0,0,1,1,1,0,0,0,
        0,0,0,1,1,1,0,0,0,
        1,0,1,1,1,1,1,0,1,
        1,1,1,1,1,1,1,1,1,
        0,0,0,1,0,1,0,0,0
    };
    
int Car::car2[6*9] = {
        0,0,1,0,0,1,1,0,0,
        0,1,0,0,1,1,1,0,0,
        0,1,1,1,1,1,0,0,0,
        1,0,1,1,1,0,0,0,0,
        0,0,0,1,1,1,1,0,0,
        0,0,1,0,0,0,0,0,0
    };
    
 int Car::car3[6*9] = {
        0,0,1,1,0,0,1,0,0,
        0,0,1,1,1,0,0,1,0,
        0,0,0,1,1,1,1,1,0,
        0,0,0,0,1,1,1,0,1,
        0,0,1,1,1,1,0,0,0,
        0,0,0,0,0,0,1,0,0
     };   